﻿--[[
	Author: Darcey@AllForTheCode.co.uk
--]]


-- Var def / ini
local updateFrame;
local origin = "BOTTOMLEFT";
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function initDCoordsMainFrame()
	log("initDCoordsMainFrame()");
	
	-- Addon gets obscured by other addons when using UIParent, see updateHandler for ALT+Z handling
	local uip = _G["UIParent"]
	local DCoordsMainFrameName = DCoords_MainFrameName .. tostring(math.random(99999999));
	log("DCoordsMainFrameName = " .. DCoordsMainFrameName);
	DCoordsMainFrame = CreateFrame("frame",DCoordsMainFrameName,uip);
	
	DCoordsMainFrame:RegisterEvent("ADDON_LOADED");
	DCoordsMainFrame:RegisterEvent("VARIABLES_LOADED");
	DCoordsMainFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	DCoordsMainFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
	DCoordsMainFrame:RegisterEvent("ZONE_CHANGED");
	DCoordsMainFrame:RegisterEvent("PLAYER_LOGOUT");	
	
	DCoordsMainFrame:SetFrameStrata("HIGH")
	DCoordsMainFrame:SetWidth(DCoords_MainFrameWidth);
	DCoordsMainFrame:SetHeight(DCoords_MainFrameHeight);
	DCoordsMainFrame:EnableMouse(false);
	DCoordsMainFrame:SetResizable(true);
	DCoordsMainFrame:SetMovable(true);
	DCoordsMainFrame:SetPoint("BOTTOMLEFT",DCoords_MainFrameX,DCoords_MainFrameY);
	--DCoordsMainFrame:SetScript("OnUpdate", function(self) DCoordsMainFrameUpdateHandler() end);
	DCoordsMainFrame:SetScript("OnMouseUp", function(self,buttonIdentifier) mouseUpHandler(self,buttonIdentifier) end);

	local DCoordsBackgroundType = DCoordsBgTypes[DCoordsSelectedBg];
	if (DCoordsBackgroundType == "classic") then
		DCoordsMainFrame:SetBackdrop({
			bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
			tile = true, tileSize = 10, edgeSize = 10,
			insets = { left = 1, right = 1, top = 1, bottom = 1 }
		})		
	else
		DCoordsMainFrame.texture = DCoordsMainFrame:CreateTexture (nil, "background");
		DCoordsMainFrame.texture:SetColorTexture(DCoords_MainFrameBgR,DCoords_MainFrameBgG,DCoords_MainFrameBgB,DCoords_MainFrameBgA);
		DCoordsMainFrame.texture:SetAllPoints(true);
	end	
	
	DCoordsMainFrameText = DCoordsMainFrame:CreateFontString(nil, 'ARTWORK');
	DCoordsMainFrameText:SetAllPoints(true);
	DCoordsMainFrameText:SetFont(getMainFrameFont(), DCoords_MainFrameFontSize,"OUTLINE");
	DCoordsMainFrameText:SetShadowOffset(1, -1);
	DCoordsMainFrameText:SetTextColor(DCoords_MainFrameTextR, DCoords_MainFrameTextG, DCoords_MainFrameTextB,DCoords_MainFrameTextA);
	DCoordsMainFrameText:SetNonSpaceWrap(false);
	DCoordsMainFrameText:SetText("Darcey@AllForTheCode.co.uk");
	--DCoordsMainFrameText:SetJustifyH("LEFT");
	DCoordsMainFrameText:SetJustifyH(alignmentTypes[DCoords_MainFrameTextAlign]);
	
	
	
	--[[
	DCoordsMainFrame:EnableMouseWheel (true);
	DCoordsMainFrame:SetScript("OnMouseWheel", function (self, delta)
		if (delta > 0) then
			DCoords_MainFrameWidth = DCoords_MainFrameWidth+10;
			DCoords_MainFrameHeight = DCoords_MainFrameHeight+0.4;
			DCoords_MainFrameFontSize = DCoords_MainFrameFontSize+0.3;
		elseif (delta < 0) then
			if (DCoords_MainFrameWidth < 100) then
				return;
			end
			DCoords_MainFrameWidth = DCoords_MainFrameWidth-10;
			DCoords_MainFrameHeight = DCoords_MainFrameHeight-0.4;
			DCoords_MainFrameFontSize = DCoords_MainFrameFontSize-0.3;
		end
		self:SetWidth(DCoords_MainFrameWidth);
		self:SetHeight(DCoords_MainFrameHeight);
		DCoordsMainFrameText:SetFont(getMainFrameFont(), DCoords_MainFrameFontSize)
		DCoordsMainFrameText:SetWidth(DCoords_MainFrameWidth);
		DCoordsMainFrameText:SetHeight(20);
		
	end)
	--]]
	
	
	
	DCoordsMainFrame:SetScript("OnEvent", function(self,event,addonName)
		if (event == "ADDON_LOADED") then
			if (addonName == "DCoords") then
				log("DCoords v"..DCoordsVersion.." ADDON_LOADED!");
			end
		elseif (event == "VARIABLES_LOADED") then
			log("DCoords v"..DCoordsVersion.." VARIABLES_LOADED!");
			DCoordsInit();
		else
			log("DCoords: WARNING: Unhandled event: [" .. event .. "]");
		end
	end);
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function updateDCoordsMainFrame()
	log("updateDCoordsMainFrame()");
	
	-- Width, Height and Font
	-- FontSize (NOTE: Height is only usable for small sizes, use SetTExtHeight to fontsize to fix)
	local txtW = DCoordsMainFrameText:GetStringWidth();
	--local txtH = DCoordsMainFrameText:GetStringHeight();
	DCoordsMainFrameText:SetFont(getMainFrameFont(), DCoords_MainFrameFontSize,"OUTLINE");
	
	if (DCoords_MainFrameSelectedBg == 2) then
		DCoordsMainFrameText:SetFont(getMainFrameFont(), DCoords_MainFrameFontSize,"OUTLINE");
		DCoordsMainFrame:SetWidth(txtW);
		--DCoordsMainFrame:SetHeight(DCoords_MainFrameHeight+450);
		local frameH = DCoords_MainFrameFontSize+6;
		if (frameH < 20) then 
			frameH = 20;
		end
		DCoordsMainFrame:SetHeight(frameH);
	else
		--local txtH = DCoordsMainFrameText:GetStringHeight();
		DCoordsMainFrame:SetWidth(txtW);
		DCoordsMainFrame:SetHeight(DCoords_MainFrameFontSize); 
	end
	
	-- Position (Had to do it manually)
	--DCoordsMainFrame:SetPoint(origin,DCoords_MainFrameX,(DCoords_MainFrameY-10));
	DCoordsMainFrame:SetPoint(origin,DCoords_MainFrameX,DCoords_MainFrameY);

	-- Drag

	DCoordsMainFrame:RegisterForDrag("LeftButton");
	
	DCoordsMainFrame:SetScript("OnDragStart", function(self)
		if (IsShiftKeyDown()) then 
			toChat("DCoords: Drag started!"); 
			self:StartMoving();
		end 
	end);
	
	DCoordsMainFrame:SetScript("OnDragStop", function(self)
		DCoords_MainFrameX = DCoordsMainFrame:GetLeft();
		DCoords_MainFrameY = DCoordsMainFrame:GetTop()-DCoordsMainFrame:GetHeight();
		self:StopMovingOrSizing()
	end);

	

	-- BG
	local tileSize = 1;
	local edgeSize = 16;
	
	if (DCoords_MainFrameShowBg == true) then

		local DCoordsBackgroundType = DCoordsBgTypes[DCoords_MainFrameSelectedBg];
		if (DCoordsBackgroundType == "classic") then
			DCoordsMainFrame.texture:SetColorTexture(0,0,0,0);
			DCoordsMainFrame:SetBackdrop({
				bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
				edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
				tile = true, tileSize = tileSize, edgeSize = edgeSize,
				insets = { left = 5, right = 5, top = 5, bottom = 5 }
			})
		else
			DCoordsMainFrame:SetBackdrop(nil);
			DCoordsMainFrame.texture:SetColorTexture(DCoords_MainFrameBgR,DCoords_MainFrameBgG,DCoords_MainFrameBgB,DCoords_MainFrameBgA);
		end	
	
	else
		DCoordsMainFrame.texture:SetColorTexture(0,0,0,0);
		DCoordsMainFrame:SetBackdrop(nil);
	end
	
	


	
	
	-- Text color	
	DCoordsMainFrameText:SetTextColor(DCoords_MainFrameTextR,DCoords_MainFrameTextG,DCoords_MainFrameTextB,DCoords_MainFrameTextAlpha);
	
	-- TExt alpha
	DCoordsMainFrameText:SetAlpha(DCoords_MainFrameTextAlpha);
	
	
	-- Visibility
	local inCombat = UnitAffectingCombat('player');

    if (inCombat == false) then
		if (DCoords_MainFrameVisible == true) then
			DCoordsMainFrame:Show();
		else
			DCoordsMainFrame:Hide();
		end
	end

	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #










-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DCoordsSlashCommandHandler(cmd)
	log("DCoordsSlashCommandHandler(): " .. cmd);
	
	if (cmd == nil or cmd == "" or string.find(cmd, "help") ~= nil) then
		toChat(" ");
		toChat("DCoords v" .. DCoordsVersion .. " slash commands:");
		toChat("  /DC show menu - show menu");
		toChat("  /DC menu - toggle menu visibility");
		toChat("  /DC show  - show coordinates");
		toChat("  /DC hide - hide coordinates");
		toChat("  /DC reset - reset position and settings");
		return;
	end
	
	strSearchResult = string.find(cmd,"reset");
	if (strSearchResult ~= nil) then
		toChat("DCoords attempting to reset positions...");
		reset();
		return;
	end
	
	if (cmd == "menu") then
		showOptions();
		return;
	end
	
	if (cmd == "show menu") then
		showOptions();
		return;
	end
		
	if (cmd == "show") then
		DCoordsMainFrame:Show();
		return;
	end
	
	if (cmd == "hide") then
		DCoordsMainFrame:Hide();
		return;
	end
	
	
	updateDCoordsMainFrame();
	updateDCoordsMapFrameState();
	updateDCoordsMenuFrameState();

	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

function showOptions()
		playClick();
		InterfaceOptionsFrame_OpenToCategory(DCoordsDB["DCoordsOptionsPages"].Main.name); -- will open interface menu
		InterfaceOptionsFrame_OpenToCategory(DCoordsDB["DCoordsOptionsPages"].Other.name); -- will  expand of sub options of DCoords
		InterfaceOptionsFrame_OpenToCategory(DCoordsDB["DCoordsOptionsPages"].Main.name); -- will select main DCoords entry
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

function mouseUpHandler(self,buttonIdentifier)

	if (buttonIdentifier == "RightButton") then
		showOptions();
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #








-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
local DCoordsMainFrameTextOldValue = "";
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
setDCoordsMainFrameText = function(value)
	--DCoordsMainFrameText:SetJustifyH("LEFT");
	DCoordsMainFrameText:SetJustifyH(alignmentTypes[DCoords_MainFrameTextAlign]);
	DCoordsMainFrameText:SetFont(getMainFrameFont(), DCoords_MainFrameFontSize,"OUTLINE");
	if (value == nil or value == "") then
		--log("setDCoordsMainFrameText(): Nil handler");
		DCoordsMainFrameText:SetText( DCoordsMainFrameText:GetText() );
	else
		if (DCoordsMainFrameTextOldValue == value) then
			--log("setDCoordsMainFrameText(): oldValue == newValue = no update");
		else
			--log("setDCoordsMainFrameText(): Value updated");
			DCoordsMainFrameText:SetText(value);
			DCoordsMainFrameTextOldValue = value;
		end
	end
	
	-- SetJustifyH sometimes works and then sometimes doesn't best not to use it!
	DCoordsMainFrameText:SetJustifyH(alignmentTypes[DCoords_MainFrameTextAlign]);
	--DCoordsMainFrameText:SetJustifyH("LEFT");  
	--log(DCoordsMainFrameText:GetJustifyH());
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupDCoordsUpdateFrame()
	updateFrame = CreateFrame("frame","DCoordsUpdateFrame");
	updateFrame:RegisterEvent("ADDON_LOADED");
	updateFrame:RegisterEvent("VARIABLES_LOADED");
	updateFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	updateFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
	updateFrame:RegisterEvent("ZONE_CHANGED");
	updateFrame:RegisterEvent("PLAYER_LOGOUT");	
	updateFrame:SetScript("OnUpdate", function(self) DCoordsMainFrameUpdateHandler() end);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #








function DCoordsInit()
	-- Ensure old variables are reset correctly
	DCoords_MainFrameDragEnabled = true;

	-- NOTE: DO NOT CALL DCoordsMainFrame() as it's called at the base of this file
	
	log("DCoordsInit()");

	-- One time calls
	SetMapToCurrentZone(); -- Works anyway but could be another addon doing that
		
	-- DCoordsMap
	initDCoordsMapFrame();
	
	-- DCoordsInterfaceOptions
	setupDCoordsInterfaceOptions();
	
	-- Update for full init
	updateDCoordsMainFrame();
	updateDCoordsMapFrameState();
	
	-- Update frame (Update frame should not be used on UIParent as bliz does things to it)
	setupDCoordsUpdateFrame();


	
	-- Setup slash commands
	SlashCmdList["DCoordsCOMMAND"] = DCoordsSlashCommandHandler;
	SLASH_DCoordsCOMMAND1 = "/dc";
	
	toChat(" ");
	toChat("DCoords v"..DCoordsVersion);
	toChat("DCoords: To view DCoords settings right click coordinates bar.");
	toChat("DCoords: To drag DCoords hold SHIFT + LEFT CLICK DRAG.");
	toChat(" ");
	
	
	
	
	
	
	
	
	
	
	
	--allowShiftMoveOfExtraActionButton();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





function qFrameMouseUpHandler(a,b)
	--toChat(tostring(a));
	--toChat(tostring(b));
end




function allowShiftMoveOfExtraActionButton()
	local bigButtonFrame = ExtraActionButton1
	--toChat(tostring(bigButtonFrame));
	if (bigButtonFrame) then
		--toChat("SETTING BIG BUTTON FRAME!");
		bigButtonFrame:EnableMouse(true);
		bigButtonFrame:SetResizable(true);
		bigButtonFrame:SetMovable(true);
		--bigButtonFrame:SetAlpha(1);
		bigButtonFrame:SetScale(0.8);
		
		if (not DCoordsDB["bigButtonFrameX"]) then
			DCoordsDB["bigButtonFrameX"] = 0;
			DCoordsDB["bigButtonFrameY"] = 0;
		end
		
		--toChat("LOADING: " .. DCoordsDB["bigButtonFrameX"]  .. "," .. DCoordsDB["bigButtonFrameY"] );
		
		bigButtonFrame:SetParent(UIParent)
		bigButtonFrame:ClearAllPoints()
		bigButtonFrame.ClearAllPoints = function() end
		bigButtonFrame:SetPoint("BOTTOMLEFT",DCoordsDB["bigButtonFrameX"],DCoordsDB["bigButtonFrameY"]);
		bigButtonFrame.SetPoint = function() end
		
		bigButtonFrame:RegisterForDrag("LeftButton");
		bigButtonFrame:SetScript("OnDragStart", function(self)
			if (IsShiftKeyDown()) then
				toChat("DCoords: Objective tracker drag started!");
				self:StartMoving();
			end 
		end);
		
		--[[
		bigButtonFrame:SetScript("OnUpdate", function(self)
			log( GetMouseFocus():GetName() );
		end);
		--]]
		
		bigButtonFrame:SetScript("OnDragStop", function(self)
			if (not DCoordsDB["bigButtonFrameX"]) then
				DCoordsDB["bigButtonFrameX"] = 0;
				DCoordsDB["bigButtonFrameY"] = 0;
			else	
				DCoordsDB["bigButtonFrameX"] = bigButtonFrame:GetLeft();
				DCoordsDB["bigButtonFrameY"] = bigButtonFrame:GetTop()-bigButtonFrame:GetHeight();
			end
			--toChat("SAVING: " .. DCoordsDB["bigButtonFrameX"]  .. "," .. DCoordsDB["bigButtonFrameY"] );
			self:StopMovingOrSizing()
		end);
		
	end
end




-- init
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
initDCoordsMainFrame();
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #










