﻿--[[
	Author: Darcey@AllForTheCode.co.uk
--]]
local DCoordsOptionsPages = {};
local sliderDecimalPrecision;
local sliderMapFontR;
local sliderMapFontG;
local sliderMapFontB;
local sliderMapFontA;
local cbDragObjectives;
local sliderObjectivesScale;
local sliderObjectivesHeight;
local sliderObjectivesAlpha;




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
reset = function()      
      DCoords_MainFrameName = "DCoordsMainFrame";
      DCoords_MainFrameVisible = true;
      DCoords_MainFrameX = 400;
      DCoords_MainFrameY = 300;
      DCoords_MainFrameWidth = 150;
      DCoords_MainFrameHeight = 10;
      DCoords_MainFrameSelectedBg = 1;
      DCoords_MainFrameShowBg = true;
      DCoords_MainFrameBgAlpha = 1;
      DCoords_MainFrameFont = 1;
      DCoords_MainFrameFontSize = 30;
      DCoords_MainFrameTextR = 1;
      DCoords_MainFrameTextG = 1;
      DCoords_MainFrameTextB = 1;
      DCoords_MainFrameTextAlpha = 1;
      DCoords_MainFrameTextAlign = 1;

      DCoords_MapFontR = 1;
      DCoords_MapFontG = 1;
      DCoords_MapFontB = 1;
      DCoords_MapFontA = 1;

      DCoords_MainFrameBgR = 0;
      DCoords_MainFrameBgG = 0;
      DCoords_MainFrameBgB = 0;
      DCoords_MainFrameBgA = 0.5;

      DCoords_MainFrameDragEnabled = true;
      DCoords_MainFrameShowZone = true;
      DCoords_MainFrameShowSubZone = true;
      DCoords_MainFrameDecimalPrecision = 2;

      DCoords_MapFrameVisible = true;
      DCoords_MapFrameFont = 1;
      DCoords_MapFrameFontSize = 16;
      DCoords_MapFrameTextAlpha = 1;
      DCoords_MapFrameSingleDecimal = true;
      
      updateDCoordsMainFrame();

      DCoordsMainFrame:ClearAllPoints();
      DCoordsMainFrame:SetPoint("CENTER",0,0);
            
      
      DCoordsDB["ObjectivesDragEnabled"] = nil;
      DCoordsDB["ObjectivesScale"] = nil;
      DCoordsDB["ObjectivesHeight"] = nil;
      DCoordsDB["ObjectivesAlpha"] = nil;
      DCoordsDB["ObjectivesX"] = nil;
      DCoordsDB["ObjectivesY"] = nil;
      DCoordsDB = null;
      DCoordsDB = nil;
      
      
      
      log("DCoords reset complete!");
      PlaySound("QUESTADDED");
      ReloadUI();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #









-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- NEW FOR BLIZ UI MENUS
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



function setupDCoordsInterfaceOptions()

      if (not DCoordsDB["DCoordsOptionsPages"]) then
            DCoordsDB["DCoordsOptionsPages"] = {};
      end
	
	setupDCoordsOptionsMainPage();
      setupDCoordsOptionsInGame();
      setupDCoordsOptionsMap();
      setupDCoordsOptionsOther();
	setDCoordsOptionsState();
	

	
	-- Call once to open interface menu, then call again to actually select the addon by name
      --[[
	InterfaceOptionsFrame_OpenToCategory(DCoordsDB["DCoordsOptionsPages"].Main.name); -- will open interface menu
	InterfaceOptionsFrame_OpenToCategory(DCoordsDB["DCoordsOptionsPages"].Other.name); -- will  expand of sub options of DCoords
      InterfaceOptionsFrame_OpenToCategory(DCoordsDB["DCoordsOptionsPages"].Main.name); -- will select main DCoords entry
      --]]
end


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function AddDCoordsOptionsTitles(targetFrame,titleExtension)
      targetFrame.MainTitle = targetFrame:CreateFontString("DCoordsPage1MainTitle", "OVERLAY")
	targetFrame.MainTitle:SetFont(getAddonDefaultFont(),24,"OUTLINE")
	targetFrame.MainTitle:SetTextColor(1,1,1)
	targetFrame.MainTitle:SetPoint("TOPLEFT", 10, -10)
      
      if (not titleExtension or titleExtension == "") then
	      targetFrame.MainTitle:SetText("DCoords v" .. DCoordsVersion);
      else
            targetFrame.MainTitle:SetText("DCoords v" .. DCoordsVersion .. "  -  " .. titleExtension);
      end
      
      targetFrame.subTitle = targetFrame:CreateFontString("DCoordsPage1subTitle", "OVERLAY")
	targetFrame.subTitle:SetFont(getAddonDefaultFont(),11,"OUTLINE")
	targetFrame.subTitle:SetTextColor(0.5,0.5,0.5)
	targetFrame.subTitle:SetPoint("TOPLEFT", 10, -30)
	targetFrame.subTitle:SetText("Darcey@AllForTheCode.co.uk");
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupDCoordsOptionsMainPage()
	DCoordsDB["DCoordsOptionsPages"].Main = CreateFrame( "Frame", "DCoordsOptionsMainPage", UIParent );
      local frame = DCoordsDB["DCoordsOptionsPages"].Main;
	frame.name = "DCoords";
	InterfaceOptions_AddCategory(frame);

      AddDCoordsOptionsTitles(frame);
      
      frame.Message1 = frame:CreateFontString("DCoordsPage1Message1", "OVERLAY")
	frame.Message1:SetFont(getAddonDefaultFont(),16,"OUTLINE")
	frame.Message1:SetTextColor(1,1,1)
	frame.Message1:SetPoint("TOPLEFT", 10, -50)
      local msg = "";
      msg = msg .. "Thanks for using DCoords!" .. "\n\n";
      msg = msg .. "Please use the menu to the left for DCoords option categories," .. "\n";
      msg = msg .. "I've made quite a few changes for this version, hopefully there wont be too many bugs!" .. "\n";
      msg = msg .. "Let me know if you have any issues and I will correct them when I can." .. "\n";
      msg = msg .. "\n\n";
      msg = msg .. "IMPORTANT CHANGES:" .. "\n\n";
      msg = msg .. "1. Drag has changed! Enable & Disable of dragging has been removed!\n";
      msg = msg .. "   You can now drag DCoords by holding down SHIFT and LEFT MOUSE HOLD TO DRAG.\n\n";
      msg = msg .. "2. Decided to make the move to the Blizard Interface Options.\n\n";
      msg = msg .. "3. Added some extra features, not coordinates related but I find them handy\n";
      msg = msg .. "   (See 'DCoords' sub menu option 'Other').\n\n";
      msg = msg .. "\n\n";
	frame.Message1:SetText(msg);
      frame.Message1:SetJustifyH("LEFT");

      
      
      
      
      
      
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupDCoordsOptionsInGame()
      DCoordsDB["DCoordsOptionsPages"].InGame = CreateFrame("FRAME", "DCoordsOptionsPagesInGame");
      local frame = DCoordsDB["DCoordsOptionsPages"].InGame;
      frame.name = "In game styling";
	frame.parent = DCoordsDB["DCoordsOptionsPages"].Main.name;
      InterfaceOptions_AddCategory(frame);
      
      AddDCoordsOptionsTitles(frame,"In game styling");
  
      local pX = 20;
      local pY = -50;
      local inc = 20;
      local sliderW = 230;
      local msg = "";
      
      msg = "Show or Hide DCoords."
      cbShowDCoords = createCheckbox(frame,"cbShowDCoords",msg,12,pX,pY,"cbShowDCoordsHandler");
      pY = pY - inc;
      cbShowZone = createCheckbox(frame,"cbShowZone","Show zone",12,pX,pY,"cbShowZoneHandler");
      pY = pY - inc;
      cbShowSubZone = createCheckbox(frame,"cbShowSubZone","Show sub zone",12,pX,pY,"cbShowSubZoneHandler");
      inc = 40;
      pY = pY - inc;
      sliderMainFontSize = createSlider(frame,"sliderMainFontSize",pX,pY,8,50,DCoords_MainFrameFontSize,"Coordinates font size",sliderW,"sliderMainFontSizeChangeHandler");
      pY = pY - inc;
      sliderTextR = createSlider(frame,"sliderTextR",pX,pY,0,1,1,"Coordinates font color Red (R)",sliderW,"sliderRChangeHandler");
      pY = pY - inc;
      sliderTextG = createSlider(frame,"sliderTextG",pX,pY,0,1,1,"Coordinates font color Green (G)",sliderW,"sliderGChangeHandler");
      pY = pY - inc;
      sliderTextB = createSlider(frame,"sliderTextB",pX,pY,0,1,1,"Coordinates font color Blue (B)",sliderW,"sliderBChangeHandler");
      pY = pY - inc;
      sliderTextA = createSlider(frame,"sliderTextA",pX,pY,0,1,1,"Coordinates font Alpha (A)",sliderW,"sliderAChangeHandler");
      pY = pY - inc;
      
      -- DCoords font dropdown
      dropDownFont = CreateFrame("FRAME", "DCoordsFontSelectionDropDown", frame, "UIDropDownMenuTemplate")
	dropDownFont:SetPoint("TOPLEFT", pX-14, pY);
      pY = pY - inc;
      
	UIDropDownMenu_SetWidth(dropDownFont, 220)
	UIDropDownMenu_SetText(dropDownFont, "Using font " .. DCoords_MainFrameFont .. " for in game coordinates","OUTLINE")
      UIDropDownMenu_Initialize(dropDownFont, function(self, level, menuList)
            local info = UIDropDownMenu_CreateInfo()
            info.func = self.SetDCoordsFont;
            for i=1,#fontFiles do
                  info.text, info.arg1, info.checked = "Font " .. tostring(i), i, false;
                  UIDropDownMenu_AddButton(info);
            end
            
      end)
      
	function dropDownFont:SetDCoordsFont(newValue)
		DCoords_MainFrameFont = newValue;
            UIDropDownMenu_SetText(dropDownFont, "Using font " .. DCoords_MainFrameFont .. " for in game coordinates","OUTLINE")
		updateDCoordsMainFrame();
            updateDCoordsMapFrameState();
            setDCoordsMainFrameText("Darcey@AllForTheCode.co.uk");
	end
      
      
      
      
      pX = 340;
      pY = -50;
      inc = 30;
      cbShowBackground = createCheckbox(frame,"cbShowBackground","Show background",12,pX,pY,"cbShowBackgroundHandler");
      pY = pY - inc;
      

      -- Background type     
      dropDownBgType = CreateFrame("FRAME", "DCoordsBgDropDown", frame, "UIDropDownMenuTemplate")
	dropDownBgType:SetPoint("TOPLEFT", pX-14, pY)
      
	UIDropDownMenu_SetWidth(dropDownBgType, 240)
	UIDropDownMenu_SetText(dropDownBgType, "Background type " .. DCoordsBgTypes[DCoords_MainFrameSelectedBg]);
      UIDropDownMenu_Initialize(dropDownBgType, function(self, level, menuList)
            local info = UIDropDownMenu_CreateInfo()
            info.func = self.SetDCoordsMainFrameBg;
            for i=1,#DCoordsBgTypes do
                  info.text, info.arg1, info.checked = DCoordsBgTypes[i], i, false;
                  UIDropDownMenu_AddButton(info);
            end
            
      end)
      
	function dropDownBgType:SetDCoordsMainFrameBg(alignmentValue)
            log("SetAlignmentValue(): " .. alignmentValue);
            DCoords_MainFrameSelectedBg = alignmentValue;
            log("DCoordsBgTypes[DCoords_MainFrameSelectedBg] = " .. DCoordsBgTypes[DCoords_MainFrameSelectedBg]);
            UIDropDownMenu_SetText(dropDownBgType, "Background type " .. DCoordsBgTypes[DCoords_MainFrameSelectedBg]);
            updateDCoordsMainFrame();
            
            if (DCoords_MainFrameSelectedBg == 1) then
                  sliderBgR:Show();
                  sliderBgG:Show();
                  sliderBgB:Show();
                  sliderBgA:Show();
            else
                  sliderBgR:Hide();
                  sliderBgG:Hide();
                  sliderBgB:Hide();
                  sliderBgA:Hide();
            end
	end
      pY = pY - 55;
      
      
      inc = 40;
      
     
      sliderBgR = createSlider(
            frame,
            "sliderBackgroundR",
            pX,pY,
            0,1,1,
            "Background Red (R)",160,"sliderBgRChangeHandler");
      pY = pY - inc;
      
      sliderBgG = createSlider(
            frame,
            "sliderBackgroundG",
            pX,pY,
            0,1,1,
            "Background Green (G)",160,"sliderBgGChangeHandler");
      pY = pY - inc;
      
      sliderBgB = createSlider(
            frame,
            "sliderBackgroundB",
            pX,pY,
            0,1,1,
            "Background Blue (B)",160,"sliderBgBChangeHandler");
      pY = pY - inc;
      
      sliderBgA = createSlider(
            frame,
            "sliderBackgroundA",
            pX,pY,
            0,1,1,
            "Background Alpha (A)",160,"sliderBgAChangeHandler");
      pY = pY - inc;
      
            
      
      
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupDCoordsOptionsMap()
      DCoordsDB["DCoordsOptionsPages"].Map = CreateFrame("FRAME", "DCoordsOptionsPagesMap");
      local frame = DCoordsDB["DCoordsOptionsPages"].Map;
      frame.name = "Map styling";
	frame.parent = DCoordsDB["DCoordsOptionsPages"].Main.name;
      InterfaceOptions_AddCategory(frame);
      
      AddDCoordsOptionsTitles(frame,"Map styling");
  
      local pX = 20;
      local pY = -50;
      local inc = 40;
      local msg = "";
      
      msg = "Show coordinates on map?"
      cbShowMapCoordinates = createCheckbox(frame,"cbShowMapCoordinates",msg,12,pX,pY,"cbShowMapCoordinatesHandler");
      pY = pY - inc;
      
     
     -- DCoords map font dropdown
      dropDownMapFont = CreateFrame("FRAME", "DCoordsMapFontSelectionDropDown2", frame, "UIDropDownMenuTemplate")
	dropDownMapFont:SetPoint("TOPLEFT", pX-14, pY);
      
	UIDropDownMenu_SetWidth(dropDownMapFont, 300)
	UIDropDownMenu_SetText(dropDownMapFont, "Using font " .. DCoords_MapFrameFont .. " for map","OUTLINE");
      UIDropDownMenu_Initialize(dropDownMapFont, function(self, level, menuList)
            local info = UIDropDownMenu_CreateInfo()
            info.func = self.SetFont;
            for i=1,#fontFiles do
                  info.text, info.arg1, info.checked = "Font " .. tostring(i), i, false;
                  UIDropDownMenu_AddButton(info);
            end
            
      end)
      
	function dropDownMapFont:SetFont(newValue)
		DCoords_MapFrameFont = newValue;
            UIDropDownMenu_SetText(dropDownMapFont, "Using font " .. DCoords_MapFrameFont .. " for map","OUTLINE")
		updateDCoordsMainFrame();
            updateDCoordsMapFrameState();
            setDCoordsMapFrameText("Darcey@AllForTheCode.co.uk");
	end
      pY = pY - inc;
      
      
      -- DCoords map text location drop down
      dropDownMapTextLocation = CreateFrame("FRAME", "DCoordsMapTextPosition", frame, "UIDropDownMenuTemplate")
	dropDownMapTextLocation:SetPoint("TOPLEFT", pX-14, pY);
      
      if (not DCoordsDB["dropDownMapTextLocationSelectedIndex"]) then
            DCoordsDB["dropDownMapTextLocationSelectedIndex"] = 2;
      end
            
      if (not DCoordsDB["dropDownMapTextLocations"]) then
            DCoordsDB["dropDownMapTextLocations"] = {
                  "Top", "Bottom"
            };
      end
      
      Coordinates_worldMapText:ClearAllPoints();
      if (DCoordsDB["dropDownMapTextLocationSelectedIndex"] == 1) then
            Coordinates_worldMapText:SetPoint("TOP", WorldMapButton, "TOP", 0, -2)
      else
            Coordinates_worldMapText:SetPoint("BOTTOM", WorldMapButton, "BOTTOM", 0, 2)
      end
      
	UIDropDownMenu_SetWidth(dropDownMapTextLocation, 300)
	UIDropDownMenu_SetText(dropDownMapTextLocation, "Map coordinates position is set to " .. DCoordsDB["dropDownMapTextLocations"][DCoordsDB["dropDownMapTextLocationSelectedIndex"]] .. ".","OUTLINE");
      UIDropDownMenu_Initialize(dropDownMapTextLocation, function(self, level, menuList)
            local info = UIDropDownMenu_CreateInfo();
            
            info.func = self.SetFont;
            for i=1,#DCoordsDB["dropDownMapTextLocations"] do
                  info.text, info.arg1, info.checked = DCoordsDB["dropDownMapTextLocations"][i], i, false;
                  UIDropDownMenu_AddButton(info);
            end
            
      end)
      
	function dropDownMapTextLocation:SetFont(newValue)
		DCoordsDB["dropDownMapTextLocationSelectedIndex"] = newValue;
            UIDropDownMenu_SetText(dropDownMapTextLocation, "Map coordinates position is set to " .. DCoordsDB["dropDownMapTextLocations"][DCoordsDB["dropDownMapTextLocationSelectedIndex"]] .. ".","OUTLINE");
		updateDCoordsMainFrame();
            updateDCoordsMapFrameState();
            setDCoordsMapFrameText("Darcey@AllForTheCode.co.uk");
            
            Coordinates_worldMapText:ClearAllPoints()
            if (newValue == 1) then
                  Coordinates_worldMapText:SetPoint("TOP", WorldMapButton, "TOP", 0, -2)
            else
                  Coordinates_worldMapText:SetPoint("BOTTOM", WorldMapButton, "BOTTOM", 0, 2)
            end
            
	end
      pY = pY - (inc*1.5);
      
      
      
      
      
      
      sliderMapFontSize = createSlider(
            frame,
            "sliderMapFontSize",
            pX,pY,
            8,50,DCoords_MapFrameFontSize,
            "Map font size",160,"sliderMapFontSizeChangeHandler");
      pY = pY - inc;
      
      sliderMapFontR = createSlider(
            frame,
            "sliderMapFontR",
            pX,pY,
            0,1,1,
            "Map font Red (R)",160,"sliderMapFontRChangeHandler");
      pY = pY - inc;

      sliderMapFontG = createSlider(
            frame,
            "sliderMapFontG",
            pX,pY,
            0,1,1,
            "Map font Green (G)",160,"sliderMapFontGChangeHandler");
      pY = pY - inc;

      sliderMapFontB = createSlider(
            frame,
            "sliderMapFontB",
            pX,pY,
            0,1,1,
            "Map font Blue (B)",160,"sliderMapFontBChangeHandler");
      pY = pY - inc;

      sliderMapFontA = createSlider(
            frame,
            "sliderMapFontA",
            pX,pY,
            0,1,1,
            "Map font Alpha (A)",160,"sliderMapFontAChangeHandler");
      pY = pY - inc;            
           
      

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupDCoordsOptionsOther()
      DCoordsDB["DCoordsOptionsPages"].Other = CreateFrame("FRAME", "DCoordsOptionsPagesOther");
      local frame = DCoordsDB["DCoordsOptionsPages"].Other;
      frame.name = "Other";
	frame.parent = DCoordsDB["DCoordsOptionsPages"].Main.name;
      InterfaceOptions_AddCategory(frame);
      
      AddDCoordsOptionsTitles(frame,"Other");
  
      local pX = 20;
      local pY = -60;
      local inc = 40;
      local msg = "";
      
      
      -- btnReset
      local btnReset = CreateFrame("button","btnReset", frame, "UIPanelButtonTemplate")
      btnReset:SetHeight(22)
      btnReset:SetWidth(150)
      btnReset:SetPoint("TOPLEFT", frame, "TOPLEFT", pX, pY)
      btnReset:SetText("RESET DCOORDS")
      btnReset:SetScript("OnClick", function(self) 
            reset();
      end)
      pY = pY - inc;
      
      
      local info = frame:CreateFontString("OtherMessage", "OVERLAY")
	info:SetFont(getAddonDefaultFont(),16,"OUTLINE")
	info:SetTextColor(1,1,1)
	info:SetPoint("TOPLEFT", pX, pY)
      msg = "";
      msg = msg .. "WARNING:\n";
      msg = msg .. "The features on this page are experimental, certain values on some options will cause strange effects.\n\n";
      msg = msg .. "FEATURE:\n" .. "Enabling Objectives Tracker features will enable Drag via SHIFT + LEFT CLICK DRAG." .. "\n\n";
      msg = msg .. "HOW TO:\n" .. "When adjusting the height of the Objective Tracker, it expands from the base upwards," .. "\n";
      msg = msg .. "I would recommend shrinking the height to it's minimum, then drag the Objectives Tracker to a position" .. "\n";
      msg = msg .. "you like, aligning it from the bottom, then adjust the height." .. ".\n";
      --msg = msg .. "FEATURE!: Enabling Special Button features will enable Drag via SHIFT + LEFT CLICK DRAG\n               (this is the big button that appears, not vehicle buttons).\n";
	info:SetText(msg);
      info:SetJustifyH("LEFT");
      pY = pY - (inc * 4);
          
      -- Objectives tracker drag
      pY = pY - 50;
      msg = "Enable Objectives Tracker features? (Disable will cause UI Reload)\nTo drag hold SHIFT + LEFT CLICK DRAG.";
      cbDragObjectives = createCheckbox(frame,"cbDragObjectives",msg,12,pX,pY,"cbDragObjectivesChangeHandler");
      pY = pY - (inc*1.5);
      
      
      
      -- Objectives scale
      if (not DCoordsDB["ObjectivesScale"]) then
            DCoordsDB["ObjectivesScale"] = 1;
      end 
      sliderObjectivesScale = createSlider(
            frame,
            "sliderObjectivesScale",
            pX,pY,
            0.5,1.5,DCoordsDB["ObjectivesScale"],
            "Objectives Scale",160,"sliderObjectivesScaleChangeHandler"
      );
      pY = pY - inc;
      
      
   
      
      -- Objectives Height
      if (not DCoordsDB["ObjectivesHeight"]) then
            DCoordsDB["ObjectivesHeight"] = 600;
      end 
      sliderObjectivesHeight = createSlider(
            frame,
            "sliderObjectivesHeight",
            pX,pY,
            200,1200,DCoordsDB["ObjectivesHeight"],
            "Objectives Height",160,"sliderObjectivesHeightChangeHandler"
      );
      pY = pY - inc;
      
      
      -- Objectives ObjectivesAlpha
      if (not DCoordsDB["ObjectivesAlpha"]) then
            DCoordsDB["ObjectivesAlpha"] = 1;
      end 
      sliderObjectivesAlpha = createSlider(
            frame,
            "sliderObjectivesAlpha",
            pX,pY,
            0,1,DCoordsDB["ObjectivesAlpha"],
            "Objectives Alpha",160,"sliderObjectivesAlphaChangeHandler"
      );
      pY = pY - inc;
      
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


















-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setDCoordsOptionsState()
      log("setDCoordsOptionsState()");
      
      cbShowDCoords:SetChecked(DCoords_MainFrameVisible);
      
      cbShowZone:SetChecked(DCoords_MainFrameShowZone);
      cbShowSubZone:SetChecked(DCoords_MainFrameShowSubZone);
      cbShowBackground:SetChecked(DCoords_MainFrameShowBg);
      
      cbShowMapCoordinates:SetChecked(DCoords_MapFrameVisible);
      
      if (sliderDecimalPrecision) then
            sliderDecimalPrecision:SetValue(DCoords_MainFrameDecimalPrecision);
      end
      
      sliderTextR:SetValue(DCoords_MainFrameTextR);
      sliderTextG:SetValue(DCoords_MainFrameTextG);
      sliderTextB:SetValue(DCoords_MainFrameTextB);
      sliderTextA:SetValue(DCoords_MainFrameTextAlpha);
      
      sliderBgR:SetValue(DCoords_MainFrameBgR);
      sliderBgG:SetValue(DCoords_MainFrameBgG);
      sliderBgB:SetValue(DCoords_MainFrameBgB);
      sliderBgA:SetValue(DCoords_MainFrameBgA);
      
      sliderMapFontR:SetValue(DCoords_MapFontR);
      sliderMapFontG:SetValue(DCoords_MapFontG);
      sliderMapFontB:SetValue(DCoords_MapFontB);
      sliderMapFontA:SetValue(DCoords_MapFontA);
      
      sliderMainFontSize:SetValue(DCoords_MainFrameFontSize);
      
      if (DCoords_MainFrameShowBg == false) then
            dropDownBgType:Hide();
            sliderBgR:Hide();
            sliderBgG:Hide();
            sliderBgB:Hide();
            sliderBgA:Hide();
      else 
            dropDownBgType:Show();
            if (DCoords_MainFrameSelectedBg == 1) then
                  sliderBgR:Show();
                  sliderBgG:Show();
                  sliderBgB:Show();
                  sliderBgA:Show();
            else
                  sliderBgR:Hide();
                  sliderBgG:Hide();
                  sliderBgB:Hide();
                  sliderBgA:Hide();
            end
      end
      
      -- Objectives tracker drag state
      if (not DCoordsDB["ObjectivesDragEnabled"]) then
            DCoordsDB["ObjectivesDragEnabled"] = false;
      end
      
      if (DCoordsDB["ObjectivesDragEnabled"]) then
            --toChat("ObjectivesDragEnabled = " .. tostring(DCoordsDB["ObjectivesDragEnabled"]));
            if (DCoordsDB["ObjectivesDragEnabled"]) then
                  enableDragOfObjectivesTracker();
            end
            cbDragObjectives:SetChecked(DCoordsDB["ObjectivesDragEnabled"]);
            
            
            -- Objectives tracker scale state
            if (not DCoordsDB["ObjectivesScale"]) then
                  DCoordsDB["ObjectivesScale"] = 0.8;
            end
            ObjectiveTrackerFrame:SetScale(DCoordsDB["ObjectivesScale"]);
            
                  
            -- Objectives Height
            if (not DCoordsDB["ObjectivesHeight"]) then
                  DCoordsDB["ObjectivesHeight"] = 600;
            end
            ObjectiveTrackerFrame:SetHeight(DCoordsDB["ObjectivesHeight"]);
            
            
            -- DCoordsDB["ObjectivesAlpha"]
            if (not DCoordsDB["ObjectivesAlpha"]) then
                  DCoordsDB["ObjectivesAlpha"] = 1;
            end
            ObjectiveTrackerFrame:SetAlpha(DCoordsDB["ObjectivesAlpha"]);
      end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #












-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function enableDragOfObjectivesTracker()
	local qFrame = ObjectiveTrackerFrame
      --toChat("enableDragOfObjectivesTracker()");
	if (qFrame) then
		qFrame:EnableMouse(true);
		qFrame:SetResizable(true);
		qFrame:SetMovable(true);
		--qFrame:SetAlpha(1);
		--qFrame:SetScale(0.8);
		
		
		
		if (not DCoordsDB["ObjectivesX"]) then
			DCoordsDB["ObjectivesX"] = qFrame:GetLeft();
			DCoordsDB["ObjectivesY"] = qFrame:GetTop();
                  
                  DCoordsDB["ObjectivesX"] = 50;
			DCoordsDB["ObjectivesY"] = 50;
		end
            
            
            --toChat(DCoordsDB["ObjectivesX"]  .. "," .. DCoordsDB["ObjectivesY"] );
		
		qFrame:ClearAllPoints()
		qFrame.ClearAllPoints = function() end
		qFrame:SetPoint("BOTTOMLEFT",DCoordsDB["ObjectivesX"],DCoordsDB["ObjectivesY"]);
		qFrame.SetPoint = function() end
		--ObjectiveTrackerFrame:SetWidth(200)
		--qFrame:SetHeight(600)
    	
		
		--qFrame.texture = qFrame:CreateTexture (nil, "background");
		--qFrame.texture:SetColorTexture(0,0,0,0.5);
		--qFrame.texture:SetAllPoints(true);
		
		
		--qFrame:SetScript("OnMouseUp", function(self,buttonIdentifier) qFrameMouseUpHandler(self,buttonIdentifier) end);
		qFrame:RegisterForDrag("LeftButton");
		qFrame:SetScript("OnDragStart", function(self)
                  if (IsShiftKeyDown()) then 
			      toChat("DCoords: Objective tracker drag started!");
			      self:StartMoving();
                  end 
		end);
		
		--[[
		qFrame:SetScript("OnUpdate", function(self)
			log( GetMouseFocus():GetName() );
		end);
		--]]
		
		qFrame:SetScript("OnDragStop", function(self)
			if (not DCoordsDB["ObjectivesX"]) then
				DCoordsDB["ObjectivesX"] = 0;
				DCoordsDB["ObjectivesY"] = 0;
			else	
				DCoordsDB["ObjectivesX"] = qFrame:GetLeft();
				DCoordsDB["ObjectivesY"] = qFrame:GetTop()-qFrame:GetHeight();
			end
			--toChat(DCoordsDB["ObjectivesX"]  .. "," .. DCoordsDB["ObjectivesY"] );
			self:StopMovingOrSizing()
		end);
		
	end

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



















-- Change handler functions
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

function cbDragObjectivesChangeHandler(value)
      DCoordsDB["ObjectivesDragEnabled"] = value;
      
      if (DCoordsDB["ObjectivesDragEnabled"]) then
            enableDragOfObjectivesTracker();
      else
            ReloadUI();
      end
end

function sliderObjectivesAlphaChangeHandler(value)
      DCoordsDB["ObjectivesAlpha"] = value;
      
      if (DCoordsDB["ObjectivesDragEnabled"]) then
            ObjectiveTrackerFrame:SetAlpha(DCoordsDB["ObjectivesAlpha"]);
      end
end


function sliderObjectivesHeightChangeHandler(value)
      DCoordsDB["ObjectivesHeight"] = value;
      
      if (DCoordsDB["ObjectivesDragEnabled"]) then
            ObjectiveTrackerFrame:SetHeight(DCoordsDB["ObjectivesHeight"]);
      end
end





function sliderObjectivesScaleChangeHandler(value)
      DCoordsDB["ObjectivesScale"] = value;
      
      if (DCoordsDB["ObjectivesDragEnabled"]) then
            ObjectiveTrackerFrame:SetScale(value);
      end
end







function sliderMainFontSizeChangeHandler(value)
      DCoords_MainFrameFontSize = value;
      updateDCoordsMainFrame();
end
function sliderMapFontSizeChangeHandler(value)
      log("sliderMapFontSizeChangeHandler(): " .. value);
      DCoords_MapFrameFontSize = value;
      updateDCoordsMapFrameState();
end



function sliderBgRChangeHandler(value)
      DCoords_MainFrameBgR = value;
      if (DCoords_MainFrameSelectedBg == 1 and DCoords_MainFrameShowBg == true) then
            DCoordsMainFrame.texture:SetColorTexture(DCoords_MainFrameBgR,DCoords_MainFrameBgG,DCoords_MainFrameBgB,DCoords_MainFrameBgA);
      end
end
function sliderBgGChangeHandler(value)
      DCoords_MainFrameBgG = value;
      if (DCoords_MainFrameSelectedBg == 1 and DCoords_MainFrameShowBg == true) then
            DCoordsMainFrame.texture:SetColorTexture(DCoords_MainFrameBgR,DCoords_MainFrameBgG,DCoords_MainFrameBgB,DCoords_MainFrameBgA);
      end
end
function sliderBgBChangeHandler(value)
      DCoords_MainFrameBgB = value;
      if (DCoords_MainFrameSelectedBg == 1 and DCoords_MainFrameShowBg == true) then
            DCoordsMainFrame.texture:SetColorTexture(DCoords_MainFrameBgR,DCoords_MainFrameBgG,DCoords_MainFrameBgB,DCoords_MainFrameBgA);
      end
end

function sliderBgAChangeHandler(value)
      DCoords_MainFrameBgA = value;
      if (DCoords_MainFrameSelectedBg == 1 and DCoords_MainFrameShowBg == true) then
            DCoordsMainFrame.texture:SetColorTexture(DCoords_MainFrameBgR,DCoords_MainFrameBgG,DCoords_MainFrameBgB,DCoords_MainFrameBgA);
      end
end





function sliderMapFontRChangeHandler(value)
      DCoords_MapFontR = value;
      updateDCoordsMapFrameState();
end
function sliderMapFontGChangeHandler(value)
      DCoords_MapFontG = value;
      updateDCoordsMapFrameState();
end
function sliderMapFontBChangeHandler(value)
      DCoords_MapFontB = value;
      updateDCoordsMapFrameState();
end

function sliderMapFontAChangeHandler(value)
      DCoords_MapFontA = value;
      updateDCoordsMapFrameState();
end





function sliderDecimalPrecisionChangeHandler(value)
      DCoords_MainFrameDecimalPrecision = value;
end
function sliderAChangeHandler(value)
      DCoords_MainFrameTextAlpha = value;
      DCoordsMainFrameText:SetTextColor(DCoords_MainFrameTextR,DCoords_MainFrameTextG,DCoords_MainFrameTextB,DCoords_MainFrameTextAlpha);
end
function sliderRChangeHandler(value)
      DCoords_MainFrameTextR = value;
      DCoordsMainFrameText:SetTextColor(DCoords_MainFrameTextR,DCoords_MainFrameTextG,DCoords_MainFrameTextB,DCoords_MainFrameTextAlpha);
end
function sliderGChangeHandler(value)
      DCoords_MainFrameTextG = value;
      DCoordsMainFrameText:SetTextColor(DCoords_MainFrameTextR,DCoords_MainFrameTextG,DCoords_MainFrameTextB,DCoords_MainFrameTextAlpha);
end
function sliderBChangeHandler(value)
      DCoords_MainFrameTextB = value;
      DCoordsMainFrameText:SetTextColor(DCoords_MainFrameTextR,DCoords_MainFrameTextG,DCoords_MainFrameTextB,DCoords_MainFrameTextAlpha);
end
function cbShowDCoordsHandler(checked)
      DCoords_MainFrameVisible = checked;
      updateDCoordsMainFrame();
end
function cbEnableDragHandler(checked)
      DCoords_MainFrameDragEnabled = checked;
      updateDCoordsMainFrame();
end
function cbShowZoneHandler(checked)
      DCoords_MainFrameShowZone = checked;
end
function cbShowSubZoneHandler(checked)
      DCoords_MainFrameShowSubZone = checked;
end
function cbShowBackgroundHandler(checked)
      DCoords_MainFrameShowBg = checked;
      updateDCoordsMainFrame();
      setDCoordsOptionsState();      
end
function cbShowMapCoordinatesHandler(checked)
      DCoords_MapFrameVisible = checked;
      updateDCoordsMapFrameState();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

